"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
function getVal(args) {
    var credCache = common_1.readCred();
    var configCache = common_1.readConfig();
    if (args["keys"].length) {
        for (var _i = 0, _a = args["keys"]; _i < _a.length; _i++) {
            var key = _a[_i];
            if (credCache[key]) {
                console.log(key + ": " + maybeStringify(credCache[key]));
            }
            else if (configCache[key]) {
                console.log(key + ": " + maybeStringify(configCache[key]));
            }
            else {
                console.log("'" + key + "' is not defined.");
                process.exit(1);
            }
        }
    }
    else {
        for (var key in configCache) {
            if (configCache.hasOwnProperty(key)) {
                console.log(key + ": " + configCache[key]);
            }
        }
    }
}
exports.getVal = getVal;
function maybeStringify(val) {
    if (typeof val === "string") {
        return val;
    }
    return JSON.stringify(val, undefined, 2);
}
