"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var common_1 = require("../common");
function setVals(args) {
    if (!common_1.isLoggedIn()) {
        console.error("ERROR: No credentials stored. Log in first with `jbcli login`.");
        process.exit(1);
    }
    for (var _i = 0, _a = args["assignments"]; _i < _a.length; _i++) {
        var assign = _a[_i];
        if (/.+=.+/.test(assign)) {
            var a = assign.split("=");
            if (common_1.forbiddenFields.indexOf(a[0]) > 0) {
                console.log(assign + " skipped: forbidden");
            }
            else {
                setVal(a[0], a[1]);
            }
        }
        else {
            console.log(assign + " skipped: syntax error");
        }
    }
}
exports.setVals = setVals;
function setVal(key, val) {
    var currentConfig = common_1.readConfig();
    currentConfig[key] = val;
    common_1.writeConfig(currentConfig);
    console.log(key + "=" + val + " set");
}
