"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("superagent");
var Throttle = require("superagent-throttle");
var common_1 = require("../common");
function deleteDeployedRecipe(args) {
    common_1.authenticate(args, _deleteDeployedRecipe);
}
exports.deleteDeployedRecipe = deleteDeployedRecipe;
function _deleteDeployedRecipe(args, host, token) {
    var ids = args["ids"];
    var environment = args["environment"] || common_1.getEnvId();
    if (!environment) {
        common_1.printDetailedError("No environment specified. Set it with `jbcli config set envId=<id>`");
        process.exit(1);
    }
    var throttle = new Throttle({
        concurrent: 1,
    })
        .on("error", function (e) { return null; });
    var baseURL = host + common_1.citizenApiPrefix + "/orgs/" + common_1.getOrgId() + "/environments/" + environment + "/recipes/";
    ids.forEach(function (id) {
        request.delete(baseURL + id)
            .use(throttle.plugin())
            .set("authToken", token)
            .end(function (err, res) {
            if (err) {
                common_1.printDetailedError("Could not delete deployed recipe with ID " + id, err);
            }
            else {
                console.log("Deployed recipe with ID " + id + " deleted.");
            }
        });
    });
}
