"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("superagent");
var common_1 = require("../common");
function deployedRecipeLog(args) {
    common_1.authenticate(args, _deployedRecipeLog);
}
exports.deployedRecipeLog = deployedRecipeLog;
function _deployedRecipeLog(args, host, token) {
    var id = args["id"];
    var reqURL = host + common_1.citizenApiPrefix + "/orgs/" + common_1.getOrgId() + "/environments/" + common_1.getEnvId() + "/recipes/" + id;
    request.get(reqURL)
        .set("authToken", token)
        .end(function (err, res) {
        if (err) {
            common_1.printDetailedError("Could not get logs for deployed recipe with ID " + id, err);
            process.exit(1);
        }
        else {
            var projectGuid = res.body["projectGuid"];
            reqURL = host + common_1.citizenApiPrefix + "/orgs/" + common_1.getOrgId() + "/environments/" + common_1.getEnvId()
                + "/operation-logs?projectGuid=" + projectGuid;
            request.get(reqURL)
                .set("authToken", token)
                .end(function (lerr, lres) {
                if (lerr) {
                    common_1.printDetailedError("Could not get logs for deployed recipe with ID " + id, err);
                    process.exit(1);
                }
                else {
                    var records = lres.body["records"];
                    if (records.length === 0) {
                        console.log("No logs found for deployed recipe with ID %s.", id);
                    }
                    else {
                        for (var _i = 0, records_1 = records; _i < records_1.length; _i++) {
                            var record = records_1[_i];
                            var started = new Date(record.attributes.operationEnteredTimestamp).toLocaleString();
                            var opName = record.attributes.operationName;
                            var status_1 = record.attributes.operationStatus;
                            var message = record.attributes.message;
                            console.log("[%s] %s - %s: %s", started, opName, status_1, message);
                        }
                    }
                }
            });
        }
    });
}
