"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsonfile = require("jsonfile");
var common_1 = require("../common");
function listEnvs(args) {
    if (!common_1.isLoggedIn()) {
        console.error("ERROR: No credentials stored. Log in first with `jbcli login`.");
        process.exit(1);
    }
    var orgs = jsonfile.readFileSync(common_1.credFile)["orgs"];
    var envs;
    for (var _i = 0, orgs_1 = orgs; _i < orgs_1.length; _i++) {
        var org = orgs_1[_i];
        if (org["orgId"] === common_1.getOrgId()) {
            envs = org["envs"];
            break;
        }
    }
    envs.sort(function (a, b) {
        if (+a.id < +b.id) {
            return -1;
        }
        if (+a.id > +b.id) {
            return 1;
        }
        return 0;
    });
    for (var _a = 0, envs_1 = envs; _a < envs_1.length; _a++) {
        var env = envs_1[_a];
        console.log("[" + env.id + "] " + env.name);
    }
}
exports.listEnvs = listEnvs;
