"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t;
    return { next: verb(0), "throw": verb(1), "return": verb(2) };
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var base64 = require("base-64");
var fs = require("fs");
var path = require("path");
var request = require("superagent");
var common_1 = require("./common");
function importJPK(args) {
    return __awaiter(this, void 0, void 0, function () {
        var cred, commit, dir;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!common_1.isLoggedIn()) {
                        console.log("Please log in first with `jbcli login`.");
                        process.exit(1);
                    }
                    cred = common_1.readCred();
                    return [4 /*yield*/, common_1.cloudStudioLogin(cred["cloudStudioHost"], cred["email"], base64.decode(cred["password"]))];
                case 1:
                    _a.sent();
                    commit = args["commit"];
                    dir = args["directory"];
                    _walkDirectoryForJPKs(dir).forEach(function (jpk) { return _read(jpk, commit); });
                    return [2 /*return*/];
            }
        });
    });
}
exports.importJPK = importJPK;
function _walkDirectoryForJPKs(dir, fileList) {
    fileList = fileList || [];
    fs.readdirSync(dir).forEach(function (file) {
        var filePath = dir + "/" + file;
        if (path.extname(file) === ".jpk") {
            fileList.push(filePath);
        }
        else if (file.charAt(0) !== ".") {
            if (fs.statSync(filePath).isDirectory()) {
                fileList = _walkDirectoryForJPKs(filePath, fileList);
            }
        }
    });
    return fileList;
}
function _read(path, commit) {
    var cred = common_1.readCred();
    var url = cred["cloudStudioHost"] + common_1.csApiPrefix + "/projects/import/jitterpak";
    var authToken = "Bearer " + cred["csAuthToken"];
    request.post(url)
        .set("Authorization", authToken)
        .type("form")
        .attach("document", path)
        .end(function (erro, res) {
        if (erro) {
            common_1.printDetailedError("Unable to upload or read JPK", erro);
        }
        else {
            var importProject_1 = res.body;
            if (importProject_1.isValid) {
                console.info(importProject_1.name + " is able to be imported.");
                if (commit) {
                    _convert(importProject_1);
                }
            }
            else {
                console.info(importProject_1.name + " is unable to be imported due to:");
                Object.keys(importProject_1.invalids).forEach(function (key) {
                    importProject_1.invalids[key].forEach(function (name) {
                        console.info("  |_ " + name + " - Component not supported yet.");
                    });
                });
            }
        }
    });
}
function _convert(importProject) {
    var cred = common_1.readCred();
    importProject.organizationId = cred["defaultOrgId"];
    importProject.environmentId = cred["defaultEnvId"];
    if (!importProject.organizationId) {
        console.error("Invalid organization for " + importProject.name);
        process.exit(1);
    }
    if (!importProject.environmentId) {
        console.error("Invalid environment for " + importProject.name);
        process.exit(1);
    }
    var url = cred["cloudStudioHost"] + common_1.csApiPrefix + "/projects/import";
    var authToken = "Bearer " + cred["csAuthToken"];
    request.post(url)
        .set("Authorization", authToken)
        .send(importProject)
        .end(function (erro, res) {
        if (erro) {
            common_1.printDetailedError("Unable to convert imported project", erro);
        }
        else {
            var project = res.body;
            if (project.id) {
                console.info(project.name + " imported to Cloud Studio successfully!");
            }
        }
    });
}
