"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsonfile = require("jsonfile");
var common_1 = require("../common");
function listOrgs(args) {
    if (!common_1.isLoggedIn()) {
        console.error("ERROR: No credentials stored. Log in first with `jbcli login`.");
        process.exit(1);
    }
    var orgs = jsonfile.readFileSync(common_1.credFile)["orgs"];
    orgs.sort(function (a, b) {
        if (+a.orgId < +b.orgId) {
            return -1;
        }
        if (+a.orgId > +b.orgId) {
            return 1;
        }
        return 0;
    });
    for (var _i = 0, orgs_1 = orgs; _i < orgs_1.length; _i++) {
        var org = orgs_1[_i];
        console.log("[" + org.orgId + "] " + org.orgName);
    }
}
exports.listOrgs = listOrgs;
