"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var request = require("superagent");
var Throttle = require("superagent-throttle");
var common_1 = require("../common");
function deleteRecipe(args) {
    common_1.authenticate(args, _deleteRecipe);
}
exports.deleteRecipe = deleteRecipe;
function _deleteRecipe(args, host, token) {
    var ids = args["ids"];
    var throttle = new Throttle({
        concurrent: 1,
    })
        .on("error", function (e) { return null; });
    var baseURL = host + common_1.citizenApiPrefix + "/orgs/" + common_1.getOrgId() + "/recipes/";
    ids.forEach(function (id) {
        request.delete(baseURL + id)
            .use(throttle.plugin())
            .set("authToken", token)
            .end(function (err, res) {
            if (err) {
                common_1.printDetailedError("Could not delete recipe with ID " + id, err);
            }
            else {
                console.log("Recipe with ID " + id + " deleted.");
            }
        });
    });
}
