"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var request = require("superagent");
var common_1 = require("../common");
function updateRecipe(args) {
    common_1.authenticate(args, _updateRecipe);
}
exports.updateRecipe = updateRecipe;
function _updateRecipe(args, host, token) {
    var id = args["id"];
    var jpk = common_1.normalizePath(args["jpk"]);
    var recipe = args["recipe"];
    var pub = args["public"].toString() || "false";
    if (!fs.existsSync(jpk)) {
        common_1.printDetailedError("Jitterpak file not found.");
        process.exit(1);
    }
    if (recipe) {
        recipe = common_1.normalizePath(recipe);
        if (!fs.existsSync(jpk)) {
            common_1.printDetailedError("Recipe file not found.");
            process.exit(1);
        }
    }
    var reqURL = host + common_1.citizenApiPrefix + "/orgs/" + common_1.getOrgId() + "/recipes/" + id;
    var r = request.put(reqURL)
        .set("authToken", token)
        .field("permissions", JSON.stringify({ public: pub }))
        .attach("jitterpack", jpk);
    if (recipe) {
        r.attach("recipe", recipe);
    }
    r.type("multipart/form-data");
    r.end(function (err, res) {
        if (err) {
            common_1.printDetailedError("Could not update recipe with ID " + id, err);
            process.exit(1);
        }
        else {
            console.log("Recipe with ID " + id + " updated.");
        }
    });
}
